﻿using IronWebScraper;
using IronWebScraperSample.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IronWebScraperSample.BlogSample
{
    /// <summary>
    /// BlogScraper
    /// </summary>
    /// <seealso cref="IronWebScraper.WebScraper" />
    public class BlogScraper : WebScraper
    {
        /// <summary>
        /// Override this method initialize your web-scraper.
        /// Important tasks will be to Request at least one start url... and set allowed/banned domain or url patterns.
        /// </summary>
        public override void Init()
        {
            License.LicenseKey = "IRONWEBSCRAPER-143290-839020-5117AB04-6F50881A-F3BC5BD8-VALID-2017";
            this.LoggingLevel = WebScraper.LogLevel.All;
            this.WorkingDirectory = AppSetting.GetAppRoot() + @"\BlogSample\Output\";
            EnableWebCache(new TimeSpan(1, 30, 30));
            this.Request("http://gizmodo.com/", Parse);
        }

        /// <summary>
        /// Override this method to create the default Response handler for your web scraper.
        /// If you have multiple page types, you can add additional similar methods.
        /// </summary>
        /// <param name="response">The http Response object to parse</param>
        public override void Parse(Response response)
        {
            foreach (var link in response.Css("div.section-nav > ul > li > a "))
            {
                
                switch(link.TextContentClean)
                {
                    case "Reviews":
                        {
                            this.Request(link.Attributes["href"], ParseReviews);// to scrap Reviews Page 
                        }
                        break;
                    case "Science":
                        {
                            this.Request(link.Attributes["href"], ParseScience);// to scrap Science Page 
                        }
                        break;
                    case "Sploid":
                        {

                        }break;
                    case "Paleofuture":
                        {

                        }break;
                    case "io9":
                        {

                        }break;
                  
                  
                    case "Field Guide":
                        {

                        }break;
                    default:
                        {
                            // Save Result to File
                            Scrape(new ScrapedData() { { "Title", link.TextContentClean } }, "BlogScraper.Jsonl");
                        }
                        break;
                }
              
            }
        }

        /// <summary>
        /// Parses the reviews.
        /// </summary>
        /// <param name="response">The response.</param>
        public void ParseReviews(Response response)
        {
            // List of Science Link
            var scienceList = new List<ScienceModel>();

            foreach (var postBox in response.Css("section.main > div > div.post-list"))
            {
                var item = new ScienceModel();
                item.Title = postBox.Css("h1.headline > a")[0].TextContentClean;
                item.Author = postBox.Css("div.author > a")[0].TextContentClean;
                item.Date = postBox.Css("div.time > a")[0].TextContentClean;
                item.Image = postBox.Css("div.image-wrapper.default-state > img")[0].Attributes["src"];
                item.Text = postBox.Css("div.summary > p")[0].TextContentClean;
                scienceList.Add(item);
            }

            Scrape(scienceList, "BlogScience.Jsonl");
        }
    }
}
