﻿using IronWebScraper;
using IronWebScraperSample.Common;
using IronWebScraperSample.MovieSample.Model;
using System;

namespace IronWebScraperSample.MovieSample
{
    public class MovieScraper : WebScraper
    {
        public override void Init()
        {
            License.LicenseKey = "LicenseKey"; 
            this.LoggingLevel = WebScraper.LogLevel.All;
            this.WorkingDirectory = AppSetting.GetAppRoot() + @"\MovieSample\Output\";
            this.Request("https://gomovies.to/", Parse);
        }
        public override void Parse(Response response)
        {
            foreach (var Divs in response.Css("#movie-featured > div"))
            {
                if (Divs.Attributes["class"] != "clearfix")
                {
                    var movie = new Movie();
                    movie.Id = Convert.ToInt32(Divs.GetAttribute("data-movie-id"));
                    var link = Divs.Css("a")[0];
                    movie.Title = link.TextContentClean;
                    movie.URL = link.Attributes["href"];
                    this.Request(movie.URL, ParseDetails, new MetaData() { { "movie", movie } });// to scrap Detailed Page                   
                }
            }
        }
        public void ParseDetails(Response response)
        {
            var movie = response.MetaData.Get<Movie>("movie");
            var Div = response.Css("div.mvic-desc")[0];
            movie.Description = Div.Css("div.desc")[0].TextContentClean;
            foreach (var Genre in Div.Css("div > p > a"))
            {
                movie.Genre.Add(Genre.TextContentClean);
            }
            foreach (var Actor in Div.Css("div > p:nth-child(2) > a"))
            {
                movie.Actor.Add(Actor.TextContentClean);
            }
            Scrape(movie, "Movie.Jsonl");
        }
    }
}
